LD_FEATURE( "SANE_EXPR" )

MEMORY
{
	/* Cortex-A8 local RAM		--  63 KB  (+ 1 KB secure)  */
	a8ram	(rwx)	: ORIGIN = 0x402F0400, LENGTH =  0xFC00
	/* OCMC0 memory			--  64 KB  */
	ocmc0	(rwx)	: ORIGIN = 0x40300000, LENGTH = 0x10000
}

ENTRY( _start )

SECTIONS
{
	.text : {
		KEEP( *(.text.header) )

		*( .text* .rodata* .data* )

		__image_end = .;
	} >ocmc0

	.bss : {
		*( .bss* COMMON )
	} >a8ram

	/DISCARD/ : {
		*(.comment .comment.* .note .note.*)
	}
}
